import Common 1.0

// Convenient component for an action sound
VariateAudioSource {

    property bool playing: actualPlaying
    property bool actualPlaying
    property bool neverStop: true
    property int playDelay
    property ObjectContainer group // Set automatically

    category: "Actions"
    fadeInTime: 0 // No fading by default for action sounds
    onPlayingChanged: {
        if (playing) {
            play()
        } else if (!neverStop) {
            fadeOut()
        }
    }

    onStarted: {
        actualPlaying = true
        if (group) group._checkPlaying()
    }
    onCompleted: {
        actualPlaying = false
        if (group) group._checkPlaying()
    }

    // TODO: inconsistent mix of fadeIn(), play() and toggleCountdown in one function. How about fadeIn(delay)?
    // Plays the sound with delay or immediately if playDelay == 0
    function play() {
        if (!_playing() && toggleCountdown <= 0) {
            variateParams()
            if (playDelay > 0) {
                toggleCountdown = playDelay
            } else if(fadeInTime > 0) {
                fadeIn()
            } else {
                _play()
            }
        }
    }

    // Fades out the sound.
    function fadeOut(delay) {
        if (_playing()) {
            if (toggleCountdown <= 0) {
                toggleCountdown = delay || 1
            }
        } else {
            toggleCountdown = 0
        }
    }
}
