import QtQuick 1.1
import Common 1.0

// Plays collection of ActionSound-s as a signle sound
ObjectContainer {

    property bool playing: actualPlaying
    property bool actualPlaying // Set automatically
    property bool neverStop: true

    property bool isTransient: true // Do not save/load state
    property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

    id: self

    onPlayingChanged: {
        if (playing) {
            play()
        } else if (!neverStop) {
            fadeOut()
        }
    }

    function play() {
        for (var i = 0; i < count(); ++i) {
            at(i).play()
        }
    }

    function fadeOut() {
        for (var i = 0; i < count(); ++i) {
            at(i).fadeOut()
        }
    }

    function _checkPlaying() {
        var p = false
        for (var i = 0; i < count(); ++i) {
            p |= at(i)._playing() || at(i).toggleCountdown > 0
        }
        actualPlaying = p
    }

    Component.onCompleted: {
        for (var i = 0; i < count(); ++i) {
            at(i).group = self
        }
    }
}
