import QtQuick 1.1
import Common 1.0

// Base component for belt pack
Item {
    // By convention a BeltPack component must have ispyList property.
    property variant ispyList: null

    // Fired when an item added to the belt pack
    signal itemAdded(variant item)
    // Fired when an item applied and removed from the belt pack
    signal itemRemoved(variant item)
    // Fired when an item is returned to the belt pack after applying or a wrong click.
    // itemX, itemY is a screen position or undefined
    signal itemReturned(variant item, variant itemX, variant itemY)

    // Fired when drag is forced to stop
    signal dragStopped

    // Fired when flickable movement ended
    signal movementEnded

    // Flickable characteritics. Readonly
    property bool horizontalFlickable: true
    property bool verticalFlickable: false

    // Loading helper
    property ObjectContainer loadedObjects: ObjectContainer {}

    // Save/load support
    function saveState() {
    }
    function loadState(data) {
        loadBeltPackBaseState(data)
    }
    function loadBeltPackBaseState(data) {
        // Puts loaded apply objects to the beltpack
        container.items.clear()
        for (var i = 0; i < loadedObjects.count(); ++i) {
            loadedObjects.at(i).putToBeltPack()
        }
        loadedObjects.clear()
    }
}
