import QtQuick 1.1
import Common 1.0

// Container for the belt pack objects. It works similar to the one row grid.
// But with manual arranging and special betlPackIndex property in ApplyObj.
QtQuickItem {

    property real cellSize: 100
    property ObjectContainer items: ObjectContainer {}
    property int cells

    height: cellSize

    // Positions items
    function arrange() {
        var cell = -1
        for (var i = 0; i < items.count(); ++i) {
            var item = items.at(i)
            if (!item.predecessor) {
                ++cell
                if (item.state !== "ReadyToApply") { // Do not arrange while dragging
                    item.x = cell * cellSize
                }
            }
            item.beltPackIndex = cell
            item._beltPackItemIndex = i
        }
        ++cell
        width = cell * cellSize
        cells = cell
    }

    function addItem(item) {
        items.append(item)
        arrange()
    }

    function removeItem(item) {
        items.removeAt(items.indexOf(item))
        arrange()
    }
}
