import QtQuick 1.1

// Manages custom cursors.
// Should be added as a top most component.
AnimatedSprite {
    property string currentCursor: (!root.rootCursorAlways && objUnderCursor && objUnderCursor.cursor) || root.cursor
    property variant hotPoints: {__dummy__: "0,0" }
    property variant animationDurations: {__dummy__: 0}
    property real hotPointX: hotPoints[currentCursor] ? hotPoints[currentCursor].split(",")[0] : 0
    property real hotPointY: hotPoints[currentCursor] ? hotPoints[currentCursor].split(",")[1] : 0
    property bool controlSystemCursors: true

    property bool isTransient: true // Do not save/load state
    property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

    visible: false
    source: Utils.resolvedUrl(game, "Cursors/Custom/" + currentCursor + ".png")
    x: cursorX - hotPointX
    y: cursorY - hotPointY
    frameCount: sourceSize.height > 0 ? sourceSize.width / sourceSize.height : 0
    animation.running: visible && frameCount > 1
    animation.loops: Animation.Infinite
    animation.duration: animationDurations[currentCursor] ? animationDurations[currentCursor] : 200 * frameCount
    animation.to: frameCount
    inactive: !visible
    asynchronous: true

    Binding {
        when: controlSystemCursors
        target: root; property: "isSystemCursorVisible"; value: !visible
    }
}
