import QtQuick 1.1
import Audio 1.0

Item {
    width: 800
    height: 600
    anchors.centerIn: parent

    Rectangle {
        anchors.fill: parent
        opacity: 0.4
        color: "Black"
    }

    Column {
        property int maxSounds

        id: table
        x: 30; y: 15;

        Row { // Header
            height: 30
            Text {
                color: "Cyan"; font.pixelSize: 16; width: 240
                text: "Audio name  (" + (table.children.length - 2) + "/" + table.maxSounds + ")"
            }
            Text { color: "Cyan"; font.pixelSize: 16; text: "Streaming"; width: 135 }
            Text { color: "Cyan"; font.pixelSize: 16; text: "Count"; width: 135 }
            Text { color: "Cyan"; font.pixelSize: 16; text: "Channels"; width: 135 }
            Text { color: "Cyan"; font.pixelSize: 16; text: "Frequency"; width: 135 }
        }

        Repeater {
            model: audioEngine.buffers

            delegate: Row {
                height: 20
                Text {
                    color: "White"; font.pixelSize: 14; width: 240
                    text: fileName.slice(fileName.indexOf("Audio/") + 6, fileName.length - 4) // Remove Audio/ and .ogg
                }
                Text { color: "White"; font.pixelSize: 14; width: 135; text: actualStreaming }
                Text { color: "White"; font.pixelSize: 14; width: 135; text: refCount }
                Text { color: "White"; font.pixelSize: 14; width: 135; text: channels }
                Text { color: "White"; font.pixelSize: 14; width: 135; text: freq }
            }
        }

        onChildrenChanged: {
            maxSounds = Math.max(maxSounds, children.length - 2)
        }
    }
}
