import QtQuick 1.1

Rectangle {

    property color selectedColor: "Green"
    property alias text: text.text
    signal clicked


    id: self
    width: 220
    height: 26
    border.color: "Grey"
    border.width: 2
    radius: 8
    smooth: true

    gradient: Gradient {
        GradientStop { position: 0.0; color: "#eeeeee" }
        GradientStop { position: 0.5; color: "#ffffff" }
        GradientStop { position: 1.0; color: "#bbbbbb" }
    }

    Gradient {
        id: pressedGradient
        GradientStop { position: 0.0; color: "#dddddd" }
        GradientStop { position: 0.5; color: "#eeeeee" }
        GradientStop { position: 1.0; color: "#777777" }
    }

    MouseArea {
        id: mouseArea
        anchors.fill: parent
        hoverEnabled: true
        preventStealing: true
        onClicked: parent.clicked()
    }

    Text {
        id: text
        anchors.centerIn: parent
        font.pixelSize: 15
        font.weight: Font.DemiBold
    }

    states: [
        State {
            name: "Pressed"; when: mouseArea.pressed; extend: "Hover"
            PropertyChanges { target: self; gradient: pressedGradient; border.color: self.selectedColor }
        },
        State {
            name: "Hover"; when: mouseArea.containsMouse
            PropertyChanges { target: self; border.color: self.selectedColor }
            PropertyChanges { target: text; color: self.selectedColor }
        }
    ]
}
