import QtQuick 1.1
import Common 1.0

// Debug menu
Item {

    default property alias buttons: buttons.children

    id: self
    anchors.fill: parent
    focus: true

    MouseArea {
        id: mouseArea; hoverEnabled: true
        anchors.left: rect.left; anchors.right: parent.right; height: rect.height
    }

    Rectangle {
        id: rect
        anchors.right: parent.right; anchors.rightMargin: -6
        width: 1028; height: buttons.height + 22; radius: 6; y: -6
        color: "#f2f2f2"
        state: mouseArea.containsMouse || buttons.containsMouse() ? "" : "Inactive"

        // Reset cursor with ObjBase on this area
        ObjBase {
            anchors.fill: parent
        }

        Grid {
            id: buttons
            x: 10; y: 14
            spacing: 7
            columns: 5

            function containsMouse() {
                for (var i = 0; i < children.length; ++i) {
                    if (children[i].containsMouse) {
                        return true
                    }
                }
            }
        }

        states: State {
            name: "Inactive"
            PropertyChanges { target: rect; y: -rect.height }
            PropertyChanges { target: mouseArea; y: -mouseArea.height + 12 }
        }
        transitions: Transition {
            NumberAnimation { properties: "y" }
        }
    }

    Keys.onPressed: {
        for (var i = 0; i < buttons.children.length; ++i) {
            var button = buttons.children[i]
            if (button.hotKey === event.key) {
                button.processClick()
                break
            }
        }
    }

}
