import QtQuick 1.1

// ToggleButton for debug menu
Rectangle {

    property Item target
    property alias text: txt.text
    property alias containsMouse: mouseArea.containsMouse
    property int hotKey
    signal clicked

    id: self
    width: 196; height: 46; radius: 6; color: "Transparent"
    state: target && target.visible ? "Selected" : ""
    Text {
        id: txt; color: "Blue"; anchors.centerIn: parent; font.pixelSize: 20
        font.underline: mouseArea.containsMouse
        MouseArea {
            id: mouseArea; anchors.fill: parent; hoverEnabled: true; preventStealing: true
            onClicked: processClick()
        }
    }

    states: [
        State {
            name: "Selected";
            PropertyChanges { target: self; color: "LightSteelBlue" }
        },
        State {
            name: "Pressed"; when: mouseArea.pressed
            PropertyChanges { target: self; color: "LightBlue" }
        }
    ]

    function processClick() {
        debug.closeAll(target)
        if (target) {
            target.visible = !target.visible
        }
        clicked()
    }
}
