import QtQuick 1.1

Text {
    color: "LightBlue"
    font.pixelSize: 18

    Timer {
        repeat: true; running: true
        onTriggered: {
            var item = activeLocation ? activeLocation.activeScreen : menu
            if (item) {
                var itemCache = {}
                var pixels = calcImageMemory(item, itemCache)
                text = (pixels * 4 / (1024 * 1024)).toFixed(1) + "mb"
            } else {
                text = "??"
            }
        }
    }

    function calcImageMemory(item, itemCache) {
        if (!itemCache[item]) {
            itemCache[item] = true

            var c = 0
            if (item.source && item.sourceSize !== undefined) { // Image, AnimatedSprite, BorderImage
                c += item.sourceSize.width * item.sourceSize.height
            }

            if (item.textureSize !== undefined) { // 3D
                c += item.textureSize.width * item.textureSize.height
            }

            for (var i = 0; i < item.children.length; ++i) {
                c += calcImageMemory(item.children[i], itemCache)
            }

            return c
        }
    }
}
