import QtQuick 1.1
import Common 1.0


// Displays obj id and state on mouse hover
Item {

    id: self
    anchors.fill: parent

    Rectangle {
        id: rect
        property ObjBase target: objUnderCursor
        width: 140
        height: 42
        border.width: 2
        border.color: "Grey"
        radius: 8
        opacity: target ? 0.7 : 0
        x: target ? game.mapFromItem(target, 0, 0).x : x
        y: target ? game.mapFromItem(target, 0, 0).y : y

        Behavior on opacity { SmoothedAnimation {} }

        Text {
            text: "id: " + (rect.target ? Utils.qmlObjId(rect.target) : "")
            x: 10; y: 5
            font.pixelSize: 14
        }
        Text {
            text: "state: " + (rect.target ? rect.target.state : "")
            x: 10; y: 22
            font.pixelSize: 14
        }
    }

    // Display mouse position
    Rectangle {
        height: 15; width: 60; opacity: 0.8; x: 90
        Text {
            anchors.centerIn: parent
            text: root.cursorX + ", " + root.cursorY
            font.pixelSize: 14
        }
    }

    // Display mouse local position
    Rectangle {
        property ObjBase obj: rect.target
        id: mouseLocalPos
        height: 15; width: 60
        opacity: 0.8; x: 90; y: 17
        visible: obj !== null
        Text {
            anchors.centerIn: parent
            text: parent.obj ? game.mapToItem(parent.obj, root.cursorX, 0).x.toFixed(0)
                      + ", " + game.mapToItem(parent.obj, 0, root.cursorY).y.toFixed(0) : ""
            font.pixelSize: 14
        }
    }
}
