import QtQuick 1.1
import Common 1.0

Image {
    property bool isTransient: true // Do not save/load state
    property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

    property int sheetIndex
    property bool moveLeftToRightOnHover
    
    property alias clickArea: mouseArea

    signal clicked
    
    z: 1

    transform: [
        Translate {
            x: mouseArea.containsMouse ? (moveLeftToRightOnHover ? 10 : -10) : 0
            Behavior on x {
                NumberAnimation { duration: 400; easing.type: Easing.InOutQuint }
            }
        },
        Scale {
            origin.x: moveLeftToRightOnHover ? 0 : width
            xScale: diary.closeAngle < 45 ? (45 - diary.closeAngle) / 45 : 0
        }
    ]
    
    

    ObjBase {
        id: mouseArea
        anchors.fill: parent
        hoverEnabled: true

        onClicked: {
            parent.clicked()
            diary.turnSheets(sheetIndex)
        }
    }
}
