import QtQuick 1.1
import Common 1.0

// Holds a page content.
// Implements page turning effect.
DiaryPageImage {
    property int pageIndex
    property real upperSheetTurn // in range [0, 2]

    shading: (0.25 + Math.abs(turn) * 0.75)  // Sheet angle shading
             * (0.2 + Math.min(upperSheetTurn, 1) * 0.8) // Shadow from the upper sheet
             * Math.min(1.5, Math.max(1, sheetContainer.children.length * 0.16)) // Make pages brighter when turning multiple sheets

    function clear() {
        for (var i = 0; i < children.length; ++i) {
            children[i].parent = deadPageContentParent
        }
    }

    transform: Rotation {
        property real closeEffectTurn: turn >= 0 ? -closeAngle : closeAngle
        axis { x: 0; y: 1; z: 0 }
        origin { x: turn >= 0 ? 0 : width; y: height * 0.5 }
        angle: closeAngle > 0 ? closeEffectTurn :
            (turn >= 0 ? -90 + 90 * turn : 90 + 90 * turn)
    }
}
