import QtQuick 1.1
import Common 1.0

// Scalable area on a diary page
ObjBase {
    id: self

    property real minScale: Math.min(_initialParent.width / childrenRect.width, maxHeight / childrenRect.height, maxScale)
    property real maxScale: 1
    property int maxHeight: 450

    property QtQuickItem _initialParent

    width: childrenRect.x + childrenRect.width
    height: childrenRect.y + childrenRect.height

    cursor: parent === _initialParent ? "Container" : scalableAreaZoomHost.cursor
    hoverEnabled: true

    scale: minScale
    transformOrigin: Item.TopLeft
    x: (_initialParent.width - width * minScale) * 0.5

    onClicked: {
        if (scalableAreaZoomHost._scalableArea) { // Redirect click if the scalable area zoomed
            scalableAreaZoomHost.clicked(mouse)
        } else if (Math.abs(findHostPage().parent.turn) === 1) {
            scalableAreaZoomHost.accept(self)
        }
    }

    Component.onCompleted: _initialParent = parent

    function findHostPage() {
        for (var p = parent; p; p = p.parent) {
            if (p.pageIndex !== undefined) {
                return p
            }
        }
    }
}
