import QtQuick 1.1
import Common 1.0

// Use cfg from a server or a local version as a fall back
ConfigLoader {
    property string fileName
    property url localSource: Utils.resolvedUrl(self, fileName)
    property string sourceInDownloadDir: cfgDownloader.downloadDir + fileName

    property bool isTransient: true // Do not save/load state
    property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

    id: self

    source: Persistence.isFile(sourceInDownloadDir) ? "file:///" + sourceInDownloadDir : localSource
}
