import QtQuick 1.1

// Abstraction for Hint and Skip Puzzle timers
QtObject {

    signal restarted
    signal filled

    // Filling time in milliseconds
    property int fillingTime: 60000
    // Filling level in range [0, 1]
    property real level: 0

    property bool enabled: true

    // For persistence
    property bool doNotCompleteAnimationsOnSave: true

    property NumberAnimation animation: NumberAnimation {
        target: self
        property: "level"
        duration: fillingTime
        from: 0; to: 1
        paused: !enabled
        onCompleted: if (level === 1) filled()
    }


    // Restart filling
    function restart() {
        animation.restart()
        restarted()
        if (developmentConfig.get("fullHint") === "true") {
            fill()
        }
    }

    // Cheat function
    function fill() {
        animation.complete()
    }

    id: self
}
