import QtQuick 1.1
import Common 1.0

// Horizontal slider.
MouseArea {
    // value must be in range [0, 1]
    property real value
    property alias thumb: thumb
    property alias background: background
    property real paddingLeft
    property real paddingRight

    property bool isTransient: true // Do not save/load state
    property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

    property real _workingWidth: background.width - paddingLeft - paddingRight

    width: 100
    height: 40

    Image {
        id: background
        anchors.centerIn: parent
        Image {
            id: thumb
            cx: paddingLeft + value * _workingWidth
            cy: background.height * 0.5
        }
    }

    onPressed: value = Math.max(0, Math.min(mouse.x - background.x - paddingLeft, _workingWidth)) / _workingWidth
    onPositionChanged: value = Math.max(0, Math.min(mouse.x - background.x - paddingLeft, _workingWidth)) / _workingWidth
}
