import QtQuick 1.1

// Describes Obj as ispy object
QtObject {

    // Name to be displayed in ispy
    property string name
    // Reference to Obj
    property Obj obj
    // This property is set by ISpyGroup
    property ISpyGroup group
    // Indicates whether this obj was found. Set by the user interaction.
    property bool found
    // Index in ISpyGroup.listModel, set by ISpyGroup
    property int index

    id: self

    property Connections connections: Connections {
        target: group && group.enabled ? obj : null
        onClicked: {
            if (obj.acceptedApplyObjs.length === 0 && obj.applyTimes === undefined) {
                obj.state = "Found"
            }
        }
        onApplyObjAccepted: {
            obj.state = "Found"
        }
        onStateChanged: {
            switch (obj.state) {
                case "ReadyToApply":
                case "Found":
                case "Applied": found = true
            }
        }
    }

    Component.onCompleted: {
        obj.hintable = !found
    }

    onFoundChanged: {
        group.listModel.setProperty(index, "found", found)
        if (found) {
            group.objectFound(self)
            game.ispyFound(group, self)
            ++group.numFound
        } else {
            --group.numFound
        }
        obj.hintable = !found
    }
}
