import QtQuick 1.1
import Common 1.0
import Audio 1.0


// Base component for menu.
QtQuickItem {

    id: self
    anchors.fill: parent

    // Independent state group allows derived components to utilize build-in state properties.
    StateGroup {
        state: self.state
        states: [
            State {
                name: "InGame"
                PropertyChanges { target: back; visible: false }
            },
            State {
                name: "Inactive"
                PropertyChanges { target: self; visible: false }
                StateChangeScript { script: Utils.setInactive(self, true) }
            },
            State {
                name: ""
                StateChangeScript { script: Utils.setInactive(self, false) }
            }
        ]
    }
}
