import QtQuick 1.1
import Common 1.0

Obj {

    id: self

    signal puzzleSolved(variant puzzle)
    signal puzzleSkipped(variant puzzle)

    property bool currentHint
    property bool isFullScreen
    property bool skipEqualSolve: true

    property string infoTxt

    state: "PuzzleOff"

    onVisibleChanged: {
        switchHintSkip()
    }
    onStateChanged: {
        switchHintSkip()
    }

    function switchHintSkip() {
        if (visible) {
            currentHint=gui.hintGUI.visible
            if (state === "PuzzleOn") {
                gui.infoGUIVisible = true
                gui.hintGUI.visible = false
                gui.skipTimer.restart()
            }
        } else if (gui) {
            gui.hintGUI.visible=currentHint
            gui.infoGUIVisible = false
        }

    }


    onPuzzleSolved: {
        gui.infoGUIVisible = false
        gui.hintGUI.visible = currentHint
    }

    //SKIP
    Connections {
        target: visible && state === "PuzzleOn" ? game : null
        onSkipPuzzle: {
            if(skipEqualSolve){
                if (isFullScreen) {
                    if (!popupLayer.isWindowOpen) puzzleSolved(self)
                } else {
                    puzzleSolved(self)
                }
            }else{
                 puzzleSkipped(self)
            }
        }
        onShowInfo:  infoShow()
    }

    function infoShow() {
        info.showObjectInfo(self)
    }

    states: [
        State {
            name: "PuzzleOff"
            //Disable skip and help buttons
        },
        State {
            name: "PuzzleOn"
            //Enable skip and help buttons
        },
        State {
            name: "Done"
        }
    ]

}
