import QtQuick 1.1
import Common 1.0

// Preload neighbour screens to populate image cache
QtObject {

    property ObjectContainer _container: ObjectContainer {}
    property ImagePreloader _imagePreloader: ImagePreloader {}

    property Connections _connections: Connections {
        target: game

        onFadingCompleted: {
            if (screen.neighbourScreensPreloadingEnabled) {
                _preloadNeighbourScreens(screen)
            }
        }

        onScreenLeft: {
            _imagePreloader.clear()
        }
    }

    function _preloadNeighbourScreens(item) {
        if (item.toScreen && Utils.isVisibleTo(item, item.parent) && item.enabled) {
            // Preload images only for main qml file
            // If you want to preload the whole dir, comment preloadForQml and uncomment preloadInDir
            //_imagePreloader.preloadInDir(item.toScreen.source)
            _imagePreloader.preloadForQml(item.toScreen.source)
        }

        for (var i = 0; i < item.children.length; ++i) {
            var child = item.children[i]
            if (child.opacity > 0) {
                _preloadNeighbourScreens(child)
            }
        }
    }

    property bool isTransient: true // Do not save/load state
    property bool isSkipForEnumeration: true // Do not enumerate on saving/loading
}
