import QtQuick 1.1
import Common 1.0

// Main stream inventory obj
InventoryObj {
    property alias tooltip: tooltip
    property alias image: image

    id: self

    // There are different sizes of image in inventory (with scale 0.8) and in award (scale 1.0)
    Image {
        id: image
        property bool isTransient: true // Do not save/load state
        property bool isSkipForEnumeration: true // Do not enumerate on saving/loading
        source: imageSource
        scale: 0.8
    }
    SimpleInventoryText { id: tooltip }

    function saveState() {
        return saveApplyObjState()
    }
    function loadState(data) {
        loadApplyObjState(data)
    }
}
