import QtQuick 1.1
import Common 1.0


// Main stream inventory zoom zone.
BeltZoomZone {
    property string name
    property url imageSource
    property url debugImageSource: imageSource
    property ZoomZoneContainer container
    property alias tooltip: tooltip
    property alias header: header
    property alias contImage: contImage
    property bool beltPackCollectable: true

    id: self
    visible: false
    height: 100; width: 100

    AnimatedSprite {
        property bool isTransient: true // Do not save/load state
        property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

        id: contImage
        anchors.fill: parent
        source: spriteSource
    }
    Image {
        property bool isTransient: true // Do not save/load state
        property bool isSkipForEnumeration: true // Do not enumerate on saving/loading

        id: header;
        source: imageSource
        scale: 0.55
        anchors.horizontalCenter: contImage.horizontalCenter
        anchors.verticalCenter: contImage.verticalCenter
        anchors.verticalCenterOffset: 7
    }
    SimpleInventoryText {
        id: tooltip
    }

    Component.onCompleted: {
        if (self.children.length > 3) {
            container = self.children[3]
        }
    }

    function putToBeltPack() {
        console.debug("putToBeltPack() called")

        for (var i=0;i<self.children.length;i++) {
            console.debug("Children "+i+" id: "+Utils.qmlObjId(self.children[i]))
        }
        if (state == "ReadyToCollect") {
            console.debug("putToBeltPack() worked")
            state = "Closed"
            visible = true
            beltPack.itemAdded(self)
            Utils.setInactive(self, false)
        }
    }
}
