import QtQuick 1.1
import Common 1.0

PuzzleObj {
    id:self

    property alias puzzleFinishObject:finishObject //Делает видимым финальный обьект извне
    // Public===========================================================================================================================================================================
    property int elemtnsNumber:5               // Общее количество элементов головоломки положения которых меняются
    //Задает возможные варианты углов для каждого элемена головоломки
    property variant statesInAngles:[/*Голова*/[-15,15,0],/*Правое плечо*/[-15,15,0],/*Левое плечо*/[-15,15,0],/*Правая нога*/[-15,15,0],/*Левая нога*/[-15,15,0]]
    property variant statesNumbers:[3,3,3,3,3] // Количество вариантов для каждого изменяемого элемента головоломки
                                               //(Должно быть равным или меньше числа вариантов в statesInAngles для данного элемента
    property variant startStates:[0,0,0,0,0]   // Список начальных положений с которых начинается головоломка

    //Задает правильный вариант положения (currentState) для каждого элемента головоломки (Если все элементы в правильных положениях - головоломка завершается!)
    property variant finishStates:[2,2,2,2,2]

    property real angleC:1.0                   // Коэфициэнт для поворота перьев
    property bool notLimitedClicks:false       // Если флаг установлен то во время анимации можно менять положение элементов(отключение данного флага исключает работу следующего флага)
    property bool blockAnimatedElement: true   // Если флаг установлен то во время анимации невозможно изменение данного объекта но возможно других
    property real animationDuration:700        // Длительность анимации
    //Private===========================================================================================================================================================================
    // Для внесения дополнительной функциональности вам может потребоваться работа с приватными параметрами (например установка пера и.т.д..)

    property variant currentStates:startStates //Отражение текущих состояний элементов головоломки. Если произошло внешнее изменение то для изменения
                                               //объектов необходимо послать сигнал currentStatesNew()!
    property int currentFinishStatesNumber:0   // Количество элементов головоломки находящихся в правильном положении на данный момент
    property bool animationRun:false           // Данный флаг поднят если в данный момент происходит анимация
    property bool blockCkicks:false            // Данный флаг используется для принудительного блокирования обработки кликов элементов головоломки
    property bool featherAccepted:false        // Вспомогательный флаг показывающий что перо установлено в головоломку.
                                               // Если этот флаг поднят то головломку можно решить, если опущен то она не решается даже если все
                                               // элементы в верном положении
    property int currentAnimationNumber:0
    property bool firstSkipClick:true          // Флаг - для защиты от многократной обработки сигнала от внешней кнопки Skip!

    signal currentStatesNew()                  // Сигнал необходимый после внешнего изменения положений элементов вашей командой

    signal skipButtonPressed()                 // Данный сигнал должен быть вызван из внешней по отношению к головоломки кнопки Skip!!!

    signal allAnimationEnd()
    signal oneAnimationBegin()
    signal oneAnimationEnd()

    Item {                                     // Объект-индикатор конечного состояния
        id:finishObject
        states:[
            State {
                name:"Finish"
            }
        ]
        transitions: [
            Transition {to: "Finish"; ScriptAction { script:{console.debug("Puzzle Finish")}}}
        ]
    }

    onSkipButtonPressed: {                                //Если нажали Skip тогда блокируем клики, переводим головоломку в финальное положение
        if (firstSkipClick) {                             //Если это первый клик по кнопке Skip..
            currentStates=finishStates                    // Меняем состояние отраженного масива на правильное
            blockCkicks=true
            currentStatesNew()                            // Посылаем сигнал о внешней смене состояния элементов головоломки
            firstSkipClick=false
        }
    }

    onOneAnimationBegin: {
        currentAnimationNumber++
        if (currentAnimationNumber===0) {animationRun=false; allAnimationEnd()}  // Увеличивает счетчик текущих анимаций на 1

    }

    onOneAnimationEnd: {
        currentAnimationNumber--
        if (currentAnimationNumber===0) {animationRun=false; allAnimationEnd()} // Уменьшает счетчик текущих анимаций на 1
    }

    onAllAnimationEnd: { // Обработчик сигнала - конец анимации. К сожелению вам придется заменить его на свой поэтому это только прототип
        animationRun=false  // Обязательный элемент, отсутствие его может нарушить функциональность головоломки
        if (!notLimitedClicks) blockCkicks=false  // Обязательный элемент если вы используете флаг notLimitedClicks
        if (featherAccepted) {                       // Опциональный элемент. В данном случае это связано с блокировкой головломки до установки пера
            if (currentFinishStatesNumber==elemtnsNumber) {  //Обязательный элемент. Производит проверку состояния головломки на предмет ее готовности
                blockCkicks=true  //  Обязательный элемент - блокирует клики по элементам головоломки после ее решения
                //eye.opacity=1     // Опциональный элемент - делает светящийся глаз феникса видимым
                //skipButton.enabled=false             // Опциональный элемент. Но общая логика для внешней кнопки Skip требует ее отключения после
                //skipButton.visible=false             // завершения головолмки
                finishObject.state="Finish"          // Обязательный элемент  - переводит финальный объект в финальное состояние
            }
        }
    }
}
