import QtQuick 1.1
import Common 1.0

//        ОПИСАНИЕ ОБЪЕКТОВ

//        объект пин - идут последовательно друг за другом сколько их там есть, нумеровать по idNumber по порядку
//        Solid - 0 означает что на пине есть верёвка изначально,
//        1 - означает что пин свободный
//        2 - "замороженный" пин
//        3 - головоломка решена (ну чтоб не тыкали)
//        функция checkPeresec - проверяет верёвки
//        функция - check - проверяет решение по координатам пинов

Obj {
    id: pin1
    property int idNumber: 1
    property int solid: 0
    property alias pinImg: sourceImg
    //    property string solidText : "this is solid pin - not moving"

    property QtQuickItem target: null

    cx: 200
    cy: 200
    z: 4
    cursor: solid === 1 ? "Container" : "Hand"

    Image {
        id: sourceImg
        width: parent.widthRope
    }
    onClicked: {
        pinRopePuzzle.pinClicked(pin1)
    }
    onPositionChanged:  {
        if(solid === 0 && first === 0){
            tmpX = cx
            tmpY = cy
            mId = idNumber
            first = 1
            state = "ReadyToApply"
            pinRopePuzzle.pinOut(pin1)
        }
        if(solid === 0 && first === 1){
            state = "ReadyToApply"
            parent.children[0].check()
            if(!(platformTraits & RootItem.PlatformNameAndroid)){
                parent.checkPeresec()
            }
        }
    }

    onReleased: {
        state =""
        target = Utils.anyObjAt(parent, dragX - container.x, dragY - container.y)
        if(target && target.idNumber){
            if(target.solid === 0 && first === 0){
                tmpX = target.cx
                tmpY = target.cy
                mId = target.idNumber
                first = 1
            }
            else if(target.solid === 2 && first === 1){
                var tmp1 = target.cx
                var tmp2 = target.cy
                target.cx = tmpX
                target.cy = tmpY
                parent.children[mId].cx = tmp1
                parent.children[mId].cy = tmp2
                first = 0
                mId = 0
                parent.children[0].check()
                parent.checkPeresec()
                pinRopePuzzle.pinOut(pin1)
            }
            else if(target.solid === 0 && first === 1){
                parent.children[mId].cx = tmpX
                parent.children[mId].cy = tmpY
                first = 0
                mId = 0
                parent.children[0].check()
                parent.checkPeresec()
                pinRopePuzzle.pinOut(pin1)
            }
            else if(target.solid === 1 && first === 1){
                parent.children[mId].cx = tmpX
                parent.children[mId].cy = tmpY
                first = 0
                mId = 0
                parent.children[0].check()
                parent.checkPeresec()
                pinRopePuzzle.pinOut(pin1)
            }

            else if(target.solid === 1 && first === 0){
            }
        } else {
            parent.children[mId].cx = tmpX
            parent.children[mId].cy = tmpY
            first = 0
            mId = 0
            parent.children[0].check()
            parent.checkPeresec()
            pinRopePuzzle.pinOut(pin1)
        }

    }
    states: [

        State {
            name: "ReadyToApply"
            PropertyChanges {
                target: parent.children[mId]
                cx: dragX - container.x // Bind x, y for dragging
                cy: dragY - container.y
                z: 5
            }
        }
    ]


}



