import QtQuick 1.1
import Common 1.0

//        ОПИСАНИЕ ОБЪЕКТОВ

//        pinRopePuzzle - головной объект для удобства работы с Childre_нами
//        rightplace - всегда должен быть 0 ребёнком, проверка правильности решения идёт по координатам Х и У,
//        первая координата для удобства счёта 0,0 и не рассматривается при проверке
//        в массив rightX,Y записать положение каждого из пинов по порядку

//        объект пин - идут последовательно друг за другом сколько их там есть, нумеровать по idNumber по порядку
//        Solid - 0 означает что на пине есть верёвка изначально,
//        2 - означает что пин свободный
//        1 - "замороженный" пин
//        3 - головоломка решена
//        функция peresec - проверяет пересечение 2 верёвок
//        функция checkPeresec - запускает проверку всех верёвок
//        функция - check - проверяет решение по координатам пинов


//        объект rope - задаётся 2 точками начала и конца (Х и Y) в соответсвующие проперти, остальное высчитывается самостоятельно


// TODO: optimize drag

Obj {
    signal pinClicked(variant pin)
    signal pinOut(variant pin)

    id: pinRopePuzzle
    anchors.fill: parent
    property int tmpX: 0
    property int tmpY: 0
    property int mId: 0
    property int first: 0
    property int pinNum: 13
    property int ropeNum: 11

    property bool winner: false

    property int mouseOffX: 0
    property int mouseOffY: 0

    //Координаты свободного пина чтобы верёвки считались неверными!!
//    property int wrongX: 328
//    property int wrongY: 400

    property variant initNumbers: [5,2,1,7,8]
    property variant initImg: []
    property variant initBigImg: []
    property variant outImg: ["","","","",""]
    property variant outBigImg: ["","","","",""]

    property int genNumbers

    property int casketNumb: 00000

    property variant randX: [610,300,425,340,495]
    property variant randY: [74,110,200,245,370]

    property variant rightX: [0,0,0,53,191,253,297,188,428,589,72,344,456,497,592,328]
    property variant rightY: [0,0,0,362,312,94,153,211,246,85,165,293,152,346,362,400]


    Item {
        id: rightPlace


        function check (){
            var i=3                                      // Проверяем состояние всех пинов
            var win=0

            //и = 3 из за 48
            for (i=3;i<=pinNum+2;++i){
                //                                console.log(i)
                //                               console.log(parent.children[i].cx,parent.children[0].rightX[i] )
                //                console.log(parent.children[c].cy,parent.children[0].rightY[c] )

                if (parent.children[i].cx == parent.rightX[i] &&
                        parent.children[i].cy == parent.rightY[i])  {
                    win++
                    //                                            console.log(win)
                    //                                            console.log(i)
                    //                                            console.log(parent.children[i].cx,parent.children[0].rightX[i] )
                    //                                            console.log(parent.children[i].cy,parent.children[0].rightY[i] )

                }
            }
            if (win == pinNum) {
                winner = true
                for (i=3;i<=pinNum+2;++i){
                    parent.children[i].solid = 3
                }
            }

        }
    }


    function genRand(){
        var flagok = 0
        var tmpmas = []
        var tmp = Math.floor(Math.random()*initNumbers.length)
        tmpmas[0] = tmp

        for(var k=1;k<initNumbers.length;k++)
        {
            tmp = Math.floor(Math.random()*initNumbers.length)
            for(var h=0;h<k;h++){
                if(tmp!==tmpmas[h])
                {
                    flagok++
                }
                else{
                    flagok--
                }
//                                console.log("RANDOMUS",tmpmas[h],tmp,flagok)
            }
            if(flagok===k)
            {
                tmpmas[k] = tmp
            }
            else{
                k--
            }
            flagok=0
            //            console.log(k,tmpmas[k])
        }
        genNumbers = tmpmas[0]*10000+tmpmas[1]*1000+tmpmas[2]*100+tmpmas[3]*10+tmpmas[4]
        reloadImg()


        //        console.log(outNumbers[0],outNumbers[1],outNumbers[2],outNumbers[3],outNumbers[4])
    }

    function reloadImg(){
        var tmpGen = []

        tmpGen[0] = Math.floor(genNumbers/10000)
        tmpGen[1] = Math.floor((genNumbers-tmpGen[0]*10000)/1000)
        tmpGen[2] = Math.floor((genNumbers-tmpGen[0]*10000-tmpGen[1]*1000)/100)
        tmpGen[3] = Math.floor((genNumbers-tmpGen[0]*10000-tmpGen[1]*1000-tmpGen[2]*100)/10)
        tmpGen[4] = Math.floor((genNumbers-tmpGen[0]*10000-tmpGen[1]*1000-tmpGen[2]*100-tmpGen[3]*10))

//        console.log("MegoFUCK",tmpGen)

        var tmpMas2 = []
        var tmpMas3 = []
        var tmpMas4 = []
        for(var k=0;k<initNumbers.length;k++){
            tmpMas2[k]=initNumbers[tmpGen[k]]
            tmpMas3[k]=initImg[tmpGen[k]]
            tmpMas4[k]=initBigImg[tmpGen[k]]
            numbers.children[tmpGen[k]].x=randX[tmpGen[k]]
            numbers.children[tmpGen[k]].y=randY[tmpGen[k]]
        }
//        for(k=0;k<5;k++)
//        {
//            console.log(tmpMas2[k],numbers.children[k].x,numbers.children[k].y)
//        }

        outImg = tmpMas3
        outBigImg = tmpMas4
        casketNumb = tmpMas2[0]*10000+tmpMas2[1]*1000+tmpMas2[2]*100+tmpMas2[3]*10+tmpMas2[4]

}

    function checkPeresec(){
        var i=1                                      // Проверяем состояние всех верёвок
        var j=1
        var mas = []

        for (i=0;i<=ropeNum-1;++i){
            //            console.log("Rope1:",Utils.qmlObjId(children[i]),"Count",i)
            for (j=i+1;j<=ropeNum-1;++j){
                peresec(children[2].children[i],children[2].children[j])
            }
            if(children[2].children[i].cross === 1){
                children[2].children[i].children[0].source=Utils.resolvedUrl(children[2].children[i], children[2].children[i].wrongSource)
            }
            else if(children[2].children[i].cross === 0){
                children[2].children[i].children[0].source=Utils.resolvedUrl(children[2].children[i], children[2].children[i].simpleSource)
            }
        }
        for (i=0;i<=ropeNum-1;++i){
            children[2].children[i].cross = 0
        }

    }


    function peresec(roper1,roper2){

        var x1 = roper1.startX
        var y1 = roper1.startY
        var x2 = roper1.endX
        var y2 = roper1.endY

        var x3 = roper2.startX
        var y3 = roper2.startY
        var x4 = roper2.endX
        var y4 = roper2.endY

        var x = ((x1*y2-x2*y1)*(x4-x3)-(x3*y4-x4*y3)*(x2-x1))/((y1-y2)*(x4-x3)-(y3-y4)*(x2-x1))
        var y = ((y3-y4)*x-(x3*y4-x4*y3))/(x4-x3)
        x*=-1

        //        console.log("Rope1:",Utils.qmlObjId(roper1),"Rope2:",Utils.qmlObjId(roper2),"Numbers:",x1,x2,x3,x4,x,"Y number:",y1,y2,y3,y4,y)


        if ((((x1<x)&&(x2>x)&&(x3<x)&&(x4>x))||((x1<x)&&(x2>x)&&(x3>x)&&(x4<x)))||(((y1<y)&&(y2>y)&&(y3<y)&&(y4>y))||((y1>y)&&(y2<y)&&(y3<y)&&(y4>y)))){

            roper1.cross = 1
            roper2.cross = 1
        }
//        else if (x1 === wrongX && y1 === wrongY || x2 === wrongX && y2 === wrongY)
//        {
//            roper1.cross = 1
//        }
//        else if (x3 === wrongX && y3 === wrongY || x4 === wrongX && y4 === wrongY)
//        {
//            roper2.cross = 1
//        }

        else{
            if(roper1.cross !== 1 ) {
                roper1.cross = 0
            }
            if( roper2.cross !== 1) {
                roper2.cross = 0
            }

        }

    }

}
