import QtQuick 1.1
import Common 1.0

Obj {

    id: rotateElement

    property variant rotateLink: [0,0]
    property alias shadowSource: shadow.source
    property alias imageSource: puzlImage.source
    property int targetRotation

    onTargetRotationChanged: {
        if (rotation !== targetRotation) {
            if (!rotateAnim.running || !rotateAnim1.running) {
                startRotate.restart()
            } else {
                if (rotateAnim1.running) {
                    rotateAnim1.stop()
                    rotateAnim.restart
                } else if (rotateAnim.running) {
                    rotateAnim.stop()
                    rotateAnim1.restart
                }
            }
        }
    }

    onClicked: {
        rotate(rotateElement)
    }


    Image {
        id: puzlImage
    }
    Image {
        id: shadow
        rotation: -rotateElement.rotation
        Behavior on opacity {NumberAnimation {duration: 100}}
    }



    PropertyAnimation on rotation {
        id: rotateAnim
        to: targetRotation; duration: rotateDuration
        onCompleted: {
            if (rotation === targetRotation) {
                endRotate.restart()
            }
        }
    }

    PropertyAnimation on rotation {
        id: rotateAnim1
        to: targetRotation; duration: rotateDuration
        onCompleted: {
            if (rotation === targetRotation) {
                endRotate.restart()
            }
        }
    }

    NumberAnimation on scale{
        id: startRotate
        duration: 150;
        easing.type: Easing.InOutQuad;
        to: 1.03

        onStarted: {
            if (endRotate.running) endRotate.stop()
            shadow.opacity = 0
        }
        onCompleted: {
            rotateAnim.restart()
        }
    }

    NumberAnimation on scale{
        id: endRotate
        duration: 150;
        easing.type: Easing.InOutQuad;
        to: 1
        onStarted: {
            shadow.opacity = 1
        }
        onCompleted: {
            if (rotation >= 360 && rotation === targetRotation) {
                //rotB.enabled = false
                rotation %= 360
                targetRotation = rotation
                checkPuzzle()
            }
        }
    }
}
