import QtQuick 1.1
import Common 1.0

Obj {
    id: rotatePuzzle

    property alias puzl1: puzl1
    property alias puzl2: puzl2
    property alias puzl3: puzl3
    property alias puzl4: puzl4
    property alias puzl5: puzl5
    property alias puzl6: puzl6
    property alias puzl7: puzl7

    property alias rotateLink1: puzl1.rotateLink
    property alias rotateLink2: puzl2.rotateLink
    property alias rotateLink3: puzl3.rotateLink
    property alias rotateLink4: puzl4.rotateLink
    property alias rotateLink5: puzl5.rotateLink
    property alias rotateLink6: puzl6.rotateLink
    property alias rotateLink7: puzl7.rotateLink

    property alias imageSource1: puzl1.imageSource
    property alias imageSource2: puzl2.imageSource
    property alias imageSource3: puzl3.imageSource
    property alias imageSource4: puzl4.imageSource
    property alias imageSource5: puzl5.imageSource
    property alias imageSource6: puzl6.imageSource
    property alias imageSource7: puzl7.imageSource

    property alias shadowSource1: puzl1.shadowSource
    property alias shadowSource2: puzl2.shadowSource
    property alias shadowSource3: puzl3.shadowSource
    property alias shadowSource4: puzl4.shadowSource
    property alias shadowSource5: puzl5.shadowSource
    property alias shadowSource6: puzl6.shadowSource
    property alias shadowSource7: puzl7.shadowSource

    property alias targetRotation1: puzl1.targetRotation
    property alias targetRotation2: puzl2.targetRotation
    property alias targetRotation3: puzl3.targetRotation
    property alias targetRotation4: puzl4.targetRotation
    property alias targetRotation5: puzl5.targetRotation
    property alias targetRotation6: puzl6.targetRotation
    property alias targetRotation7: puzl7.targetRotation

    property int rotateDuration: 500

    property bool solved

    property variant winRotation: [0,0,0,0,0,0,0]
    
    signal rotationStart

    function checkPuzzle() {

        var i;
        var propName;
        var win;

        for (i = 0; i < children.length; i++) {
            win = children[i].targetRotation === children[i].rotation && children[i].rotation === winRotation[i]
            if (!win) break;
        }

        if (win) {
            solved = true
        }
    }


    function rotate(PuzlElement) {

        var i;
        var propName;
        rotatePuzzle.rotationStart()
        for (i = 0; i < PuzlElement.rotateLink.length; i += 2) {
            children[PuzlElement.rotateLink[i]-1].targetRotation += PuzlElement.rotateLink[i+1]
        }
    }


    RotateElement {
        id: puzl1
        cx: 255
        cy: 190
        z: 1
        rotateLink: [1,60,3,120]
    }


    RotateElement {
        id: puzl2
        cx: 156
        cy: 135
        z: 1
        rotateLink: [2,60,5,60]
    }


    RotateElement {
        id: puzl3
        cx: 254
        cy: 79
        z: 1
        rotateLink: [3,60,7,120]
    }


    RotateElement {
        id: puzl4
        cx: 350
        cy: 135
        z: 1
        rotateLink: [4,60,3,120]
    }


    RotateElement {
        id: puzl5
        cx: 350
        cy: 247
        z: 1
        rotateLink: [7,60,5,120]
    }


    RotateElement {
        id: puzl6
        cx: 254
        cy: 300
        z: 1
        rotateLink: [3,60,5,60,6,60]
    }


    RotateElement {
        id: puzl7
        cx: 158
        cy: 247
        z: 1
        rotateLink: [7,60]
    }


}
