import QtQuick 1.1
import Common 1.0

PuzzleObj {
    id:self
    // **Пример использования объекта с коментариями смотрим ниже, после кода
    // Public====================================================================================================================================================
    // Переменная содержащая начальный! порядок элементов внутри головоломки (позиция - адрес ячейки,значение - номер элемента который находится по этому адресу)
    property variant matrix:[16,4,11,7 ,           // Данный массив создается только для удобства если вы хотите легко менять начальное состояние
                             6, 8, 2 ,9,           // если не требуется часто его менять то можно убрать ссылки на него из объектов-элементов головломки
                             10,12,5, 1,           // но тогда при изменении начального порядка элементов вам придется менять данные измененных объектов
                             14, 3,15, 13]         // в ручную!

    property int matrixElementsNumber: 16          // Количество элементов головоломки
    property real animationDuration: 1000         // Длительность анимации во время нормальной работы головоломки
    property real cancelAnimationDuration:2000     // Длительность анимации после нажатия кнопки skipButton
    property bool notLimitedClicks:false          // Флаг разрешает менять элементы головоломки во время анимации
    property int endAnimation:1                   // Номер конечной анимации, пока есть только 1 - все элементы головломки становятся на свои места разом..
                                                  // ..и 2 - головоломка собирается пошагово, в остальных случаях анимации не будет вообще!
    // Private==========================================================================================================================================
    property int oldClickElement:0
    property variant matrixX:[]
    property variant matrixY:[]
    property variant matrixId:[]
    property variant matrixPositions:[]
    property bool animationRun:false
    property bool cancelEnable:false
    property bool blockClicks:false
    property bool afterAnimationEndFinish: false
    property bool oldClickElementFlag:false
    property int currentAnimationNumber:0

    signal allAnimationEnd()
    signal oneAnimationBegin()
    signal oneAnimationEnd()

    function oneElementToFinish() { // Функция находит первый элемент не на своем месте - производит его перемещение
        var safeOwnMatrixPosition
        var safeOwnCX
        var safeOwnCY
        var c=0
        var c1=0
        var exit=false
        while ((puzzleCore.children[c].idNumber===puzzleCore.children[c].matrixPosition)&&(!exit)){//Находим элемент не на своем месте
            if(c===(matrixElementsNumber-1)) exit=true
            else c++
        }
        if (!exit ) {
            while (puzzleCore.children[c1].idNumber!==puzzleCore.children[c].matrixPosition) {c1++} // Ищем элемент который должен быть на этом месте
            safeOwnMatrixPosition=puzzleCore.children[c].matrixPosition                             // Сохраняем позицию
            safeOwnCX=puzzleCore.children[c].cx
            safeOwnCY=puzzleCore.children[c].cy
            puzzleCore.children[c].cx=puzzleCore.children[c1].cx
            puzzleCore.children[c].cy=puzzleCore.children[c1].cy
            puzzleCore.children[c1].cx=safeOwnCX
            puzzleCore.children[c1].cy=safeOwnCY
            puzzleCore.children[c].matrixPosition=puzzleCore.children[c1].matrixPosition
            puzzleCore.children[c1].matrixPosition=safeOwnMatrixPosition
        }
        return exit
    }


    function searchInVariant(inId,inVariant) {// Функция переводит все элементы головломки на свои места
        var c=0
        while (inVariant[c]!==inId) {c++}
        return c
    }

    function allElementsToFinish(){
        var c=0
        var tempX=matrixX
        var tempY=matrixY
        var tempId=matrixId
        var tempPositions=matrixPositions
        for (c=0;c<=(matrixElementsNumber-1);++c){
            tempX[c]=puzzleCore.children[c].cx
            tempY[c]=puzzleCore.children[c].cy
            tempId[c]=puzzleCore.children[c].idNumber
            tempPositions[c]=puzzleCore.children[c].matrixPosition
        }
        c=0
        for (c=0;c<=(matrixElementsNumber-1);++c){
            puzzleCore.children[searchInVariant(c+1,tempId)].cx=tempX[searchInVariant(c+1,tempPositions)] // Хотя массив начинается с 0 но положения и Id с 1!
            puzzleCore.children[searchInVariant(c+1,tempId)].cy=tempY[searchInVariant(c+1,tempPositions)]
        }
    }

    Item {                      // Объект-индикатор конечного состояния
        id:finishObject
        states:[
            State {
                name:"Finish"
            }
        ]
        transitions: [
            Transition {to: "Finish"; ScriptAction { script:{console.debug("Puzzle Finish")}}}
        ]
    }



    Obj {                                   // Объект-кнопка Скип!
        id: skipButton
        cx:440
        width: 120; height: 35
        enabled: true
        visible: true
        Rectangle {
            anchors.fill: parent
            border.color: "Red"
            border.width: 3
        }
        Text {
            color: "Black"
            font.pointSize: 18
            text:"Skip Button"
        }
        onClicked: {                        // Если нажали Skip тогда блокируем клики, переводим головоломку в финальное положение
            skipButton.enabled=false
            animationDuration=cancelAnimationDuration
            blockClicks=true
            if (endAnimation===1) {
                allElementsToFinish ()
                afterAnimationEndFinish=true
            }
            if (endAnimation===2) {
                cancelEnable=true
            }
            if (!animationRun) allAnimationEnd()
        }
    }

    onOneAnimationBegin: {
        currentAnimationNumber++
        if (currentAnimationNumber===0) {animationRun=false;allAnimationEnd()}

    }

    onOneAnimationEnd: {
        currentAnimationNumber--
        if (currentAnimationNumber===0) {animationRun=false;allAnimationEnd()}
    }

    onAllAnimationEnd: {
        var c=1                                      // Проверяем состояние всех элементов головоломки
        var passElementNumber=0
        for (c=0;c<=(matrixElementsNumber-1);++c){
            if (puzzleCore.children[c].idNumber===puzzleCore.children[c].matrixPosition)  passElementNumber++
        }
        if ((passElementNumber===matrixElementsNumber)||(afterAnimationEndFinish)) {  // Если все в верном состоянии отключаем кнопку Skip и завершаем головоломку
            skipButton.enabled=false
            skipButton.visible=false
            blockClicks=true
            finishObject.state="Finish"
        }
        else {if (cancelEnable) oneElementToFinish() } // Если поднят флаг анимации авторешения то перемешяем 1 элемент на свое место.
    }
}

// Позиция(matrixPosition) элемента должна соответствовать координатам. Для решения головломки необходимо чтобы номер-идентификатор(idNumber) был равен
// позиции(matrixPosition) у всех элементов головломки. Номер-идентификатор (idNumber) определяет правильную позицию в которой должен находится объект
// головоломки для решения. Номер-идентификатор (idNumber) и изображение связанное с объектом(imageSource) - не меняются после создания объекта, поэтому
// они могут быть по желанию использованы для удобной смены порядка через массив matrix. Также никто не мешает задать всем объектам положение(matrixPosition)
// и соотвественно координаты(cx,cy) для начального порядка если это удобно.
/*
        PuzzleShellLib {            // Наш объект
            id:puzzle1

            matrix:[4,1,            // Задает начальный порядок элементов только если файлы изображений правильно проименованы с 1 и до matrixElementsNumber
                    3,2]
            matrixElementsNumber: 4
            endAnimation:1
            cancelAnimationDuration:2000

            Item {                 // Специальный объект-контейнер для элементов головоломки! его имя нельзя менять! добавлять в него элементы можно только
                id:puzzleCore      // после объектов-элементов головоломки.

                ShieldTileLib { idNumber: puzzle1.matrix[0]; matrixPosition:1; cy:115; cx: 115; imageSource: "ShieldTile"+puzzle1.matrix[0]+".png"}
                ShieldTileLib { idNumber: puzzle1.matrix[1]; matrixPosition:2; cy:115; cx: 205; imageSource: "ShieldTile"+puzzle1.matrix[1]+".png"}
                ShieldTileLib { idNumber: puzzle1.matrix[2]; matrixPosition:3; cy:205; cx: 115; imageSource: "ShieldTile"+puzzle1.matrix[2]+".png"}
                ShieldTileLib { idNumber: puzzle1.matrix[3]; matrixPosition:4; cy:205; cx: 205; imageSource: "ShieldTile"+puzzle1.matrix[3]+".png"}

                // Вариант без matrix. Теперь чтобы поменять порядок нужно либо менять idNumber и imageSource, либо менять matrixPosition и cx,cy
                //ShieldTileLib { idNumber: 1; matrixPosition:1; cy:115; cx: 115; imageSource: "пауксиний.png"}
                //ShieldTileLib { idNumber: 2; matrixPosition:2; cy:115; cx: 205; imageSource: "пауккрасный.png"}
                //ShieldTileLib { idNumber: 3; matrixPosition:3; cy:205; cx: 115; imageSource: "паукзеленый.png"}
                //ShieldTileLib { idNumber: 4; matrixPosition:4; cy:205; cx: 205; imageSource: "паукжелтый.png"}

            }
*/
