import QtQuick 1.1
import Common 1.0

Obj {
    id:self
    // Public=============================================================================================================================================
    // Все 3 параметра для задействованых в головоломке объектов должны быть явно заданы при инициализации объекта!
    property alias imageSource:selfImage.source            // Изображение которое будет присоединено к объекту

    property int idNumber:0                                // Номер-идентификатор объекта элемента головоломки (Начинается с 1!!)
    property int matrixPosition:0                          // Текущая позиция элемента в матрице (Начинается с 1!!)
    // Позиция(matrixPosition) элемента должна соответствовать координатам. Для решения головломки необходимо чтобы номер-идентификатор(idNumber) был равен
    // позиции(matrixPosition) у всех элементов головломки. Номер-идентификатор (idNumber) определяет правильную позицию в которой должен находится объект
    // головоломки для решения. Номер-идентификатор (idNumber) и изображение связанное с объектом(imageSource) - не меняются после создания объекта, поэтому
    // они могут быть по желанию использованы для удобной смены порядка через массив matrix. Также никто не мешает задать всем объектам положение(matrixPosition)
    // и соотвественно координаты(cx,cy) для начального порядка если это удобно.
    // Private============================================================================================================================================
    property bool runAnimation:false

    function searchId(inId) {
        var c=0
        while (puzzleCore.children[c].idNumber!==inId) {c++}
        return c
    }

    Image {
        id:selfImage
    }

    onClicked: {
        if (!self.parent.parent.blockClicks) {
            if ((!self.parent.parent.animationRun)||(self.parent.parent.notLimitedClicks)) {
                if (self.parent.parent.oldClickElementFlag) {
                    if (self.parent.parent.oldClickElement!==self.idNumber) {
                        var safeOwnMatrixPosition=self.matrixPosition                 // Сохраняем позицию
                        var safeOwnCX=self.cx
                        var safeOwnCY=self.cy
                        self.cx=puzzleCore.children[searchId(self.parent.parent.oldClickElement)].cx
                        self.cy=puzzleCore.children[searchId(self.parent.parent.oldClickElement)].cy
                        puzzleCore.children[searchId(self.parent.parent.oldClickElement)].cx=safeOwnCX
                        puzzleCore.children[searchId(self.parent.parent.oldClickElement)].cy=safeOwnCY
                        self.matrixPosition=puzzleCore.children[searchId(self.parent.parent.oldClickElement)].matrixPosition
                        puzzleCore.children[searchId(self.parent.parent.oldClickElement)].matrixPosition=safeOwnMatrixPosition
                        self.parent.parent.oldClickElementFlag=false
                    }
                    else  self.parent.parent.oldClickElementFlag=false;
                }
                else {self.parent.parent.oldClickElement=self.idNumber; self.parent.parent.oldClickElementFlag=true}
            }
        }
    }


    Behavior on cx {
        SequentialAnimation {
            id:cxAnimation
            ScriptAction{script:{self.enabled=false;self.z=1}}
            PropertyAnimation { target:self; property: "cx"; easing.type: Easing.InOutQuad; duration: self.parent.parent.animationDuration }
            ScriptAction{script:{self.enabled=true;self.z=0}}
            onRunningChanged: {
                 if (!cxAnimation.running) self.parent.parent.oneAnimationEnd()
                 else {self.parent.parent.oneAnimationBegin(); if (!self.parent.parent.animationRun) self.parent.parent.animationRun=true }
            }
        }
    }

    Behavior on cy {
        SequentialAnimation {
            id: cyanimation
            ScriptAction{script:{self.enabled=false;self.z=1}}
            PropertyAnimation { target:self; property: "cy"; easing.type: Easing.InOutQuad; duration: self.parent.parent.animationDuration }
            ScriptAction{script:{self.enabled=true;self.z=0}}
            onRunningChanged: {
                if (!cxAnimation.running) parent.parent.oneAnimationEnd()
                else {self.parent.parent.oneAnimationBegin(); if (!self.parent.parent.animationRun) self.parent.parent.animationRun=true }
            }
        }
    }

}

